/*Functions for different shaped apertures*/
/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/

float FilterFunc1(float x,float y,float a)
{
  /*Parabolic Round*/
  float r2;
  r2=x*x+y*y;
  if (r2<=(a*a)) return(1-r2/(a*a));
  else return(0.0);
}

float FilterFunc2(float x,float y,float a)
{
  /*Straight Square
    note that 2*a is the length of a side*/
  float z;
  z=0.;
  if ((abs(x)<(a))&&(abs(y)<(a))) z=1.0;
  return(z);
}

float FilterFunc3(float x,float y,float a,float b)
{
  /*Circular Mesa*/
  float r,z;
  r=sqrt(x*x+y*y);
  if (r<a) z=1.;
  else if (r<b) z=1.-(r-b)/(a-b);
  else z=0.;
  return(z);
}
