/*Make a vector*/
/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

float *vector1d (int first, int last)
{
  float *v;
  v=(float *)malloc((size_t) ((last-first+2)*sizeof(float)));
  if (!v) {fprintf(stderr,"Allocation Failure in vector1d\n");exit(1);}
  return v-first+1;
}

int *ivector1d (int first, int last)
{
  int *v;
  v=(int *)malloc((size_t) ((last-first+2)*sizeof(int)));
  if (!v) {fprintf(stderr,"Allocation Failure in ivector1d\n");exit(1);}
  return v-first+1;
}

int **ivector2d (int firstrow, int lastrow, int firstcol, int lastcol)
{
  int i, nrow=lastrow-firstrow+1,ncol=lastcol-firstcol+1;
  int row=firstrow;
  int **m;
  m=(int **)malloc((size_t)((nrow+1)*sizeof(int*)));
  if (!m) {fprintf(stderr,"IVector2D error at point 1\n");exit(1);}
  m+= 1;
  m-= row;
  m[firstrow]=(int *)malloc((size_t)((nrow*ncol+1)*sizeof(int)));
  if (!m[row]) {fprintf(stderr,"IVecotor2D error at point2\n");exit(1);}
  m[row]+=1;
  m[row]-=firstcol;
  for (i=row+1;i<=lastrow;i++) m[i]=m[i-1]+ncol;
  return m;
}

float **vector2d (int firstrow, int lastrow, int firstcol, int lastcol)
{
  int i, nrow=lastrow-firstrow+1,ncol=lastcol-firstcol+1;
  int row=firstrow;
  float **m;
  m=(float **)malloc((size_t)((nrow+1)*sizeof(float*)));
  if (!m) {fprintf(stderr,"Vector2D error at point 1\n");exit(1);}
  m+= 1;
  m-= row;
  m[firstrow]=(float *)malloc((size_t)((nrow*ncol+1)*sizeof(float)));
  if (!m[row]) {fprintf(stderr,"Vecotor2D error at point2\n");exit(1);}
  m[row]+=1;
  m[row]-=firstcol;
  for (i=row+1;i<=lastrow;i++) m[i]=m[i-1]+ncol;
  return m;
}

double **dvector2d (int firstrow, int lastrow, int firstcol, int lastcol)
{
  int i, nrow=lastrow-firstrow+1,ncol=lastcol-firstcol+1;
  int row=firstrow;
  double **m;
  m=(double **)malloc((size_t)((nrow+1)*sizeof(double*)));
  if (!m) {fprintf(stderr,"DVector2D error at point 1\n");exit(1);}
  m+= 1;
  m-= row;
  m[firstrow]=(double *)malloc((size_t)((nrow*ncol+1)*sizeof(double)));
  if (!m[row]) {fprintf(stderr,"DVecotor2D error at point2\n");exit(1);}
  m[row]+=1;
  m[row]-=firstcol;
  for (i=row+1;i<=lastrow;i++) m[i]=m[i-1]+ncol;
  return m;
}

void ifree2d(int **v, int firstrow, int firstcol)
{
  free(v[firstrow]+firstcol-1);
  free(v+firstrow-1);
}

void free2d(float **v, int firstrow, int firstcol)
{
  free(v[firstrow]+firstcol-1);
  free(v+firstrow-1);
}

void dfree2d(double **v, int firstrow, int firstcol)
{
  free(v[firstrow]+firstcol-1);
  free(v+firstrow-1);
}
