/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
float SumApp(double **apix, long *naxes, float x0,float y0,int filtype,
	     float a, float b,int psum,int *nl);


void PeakUp(double **apix, long *naxes,double *x,double *y, float frad)
     //Find the peak of the flux distribution with initial guess x & y
{
  int nmove,np,debug;
  float step,last;

  debug=0;
  if (debug) fprintf(stderr,"Start Peakup (%f,%f)\n",*x,*y);
  frad=1.5; //filter radius
  last=SumApp(apix,naxes,*x,*y,1,frad,0.0,1,&np);
  for (step=0.5;step>.01;step=step/2.) {
    do{
      nmove=0;
      //increase in positive x?
      while (last<SumApp(apix,naxes,*x+step,*y,1,frad,0.0,1,&np))
	{
	  *x+=step;
	  nmove++;
	  last=SumApp(apix,naxes,*x,*y,1,frad,0.0,1,&np);
	}
      //increase in negative x?
      while (last<SumApp(apix,naxes,*x-step,*y,1,frad,0.0,1,&np))
	{
	  *x-=step;
	  nmove++;
	  last=SumApp(apix,naxes,*x,*y,1,frad,0.0,1,&np);
	}
      //increase in positive y?
      while (last<SumApp(apix,naxes,*x,*y+step,1,frad,0.0,1,&np))
	{
	  *y+=step;
	  nmove++;
	  last=SumApp(apix,naxes,*x,*y,1,frad,0.0,1,&np);
	}
      //increase in negative y?
      while (last<SumApp(apix,naxes,*x,*y-step,1,frad,0.0,1,&np))
	{
	  *y-=step;
	  nmove++;
	  last=SumApp(apix,naxes,*x,*y,1,frad,0.0,1,&np);
	}
    } while (nmove>0);
    if (debug) fprintf(stderr,"End of Step = %f, (x,y)=(%f,%f)\n",step,*x,*y);
  }
}
