/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/
#include "fitsio.h"
#include "stdlib.h"
#include "string.h"
/*be sure to compile with -Lcfitsio */
 
int readfits(char *fn,int naxis,long naxes[3],double **array,int hdu,
             int *status)
{
  fitsfile *fptr;
  double *test;
  int x,y,nhdu,type;
                                                                                
  test=(double *)malloc(sizeof(double)*naxes[0]);
  if (*status<=0)
    {
      if (ffopen(&fptr,fn,READONLY,status))
      {
        ffrprt(stderr,*status);
      }
          else
      {
        nhdu=1;
        while (nhdu<hdu)
          {
            ffmrhd(fptr,1,&type,status);
            nhdu++;
          }
        for (y=0;y<naxes[1];y++) {
          ffgpv(fptr,TDOUBLE,(y*naxes[0]+1),naxes[0],NULL,test,NULL,status);
          for (x=0;x<naxes[0];x++) array[y][x]=test[x];
        }
        ffclos(fptr,status);
      }
    }
  return(*status);
}
 

