/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "filters.h"


float SumApp(double **apix, long *naxes, float x0,float y0,int filtype,
			float a, float b,int psum,int *nl)
{
  /* if psum >0 retun the average pixel value in the aperture otherwise
     return the straight weighted sum over the aperture*/
  int i,j;
  int r1,r2,c1,c2,np;
  float x,y,sum,ff,wsum;
  int debug=0;

  //Recall that while the array starts indexed at 0, the first pixel is 1
  x0=x0-1;
  y0=y0-1;
  //setup integration bounds.... restrict to CCD bounds!
  c1=x0-a-1;
  if (c1<0) c1=0;
  c2=x0+a+1;
  if (c2>=naxes[0]) c2=naxes[0]-1;
  r1=y0-a-1;
  if (r1<0) r1=0;
  r2=y0+a+1;
  if (r2>=naxes[1]) r2=naxes[1]-1;
  
  sum=0.;
  wsum=0;
  np=0;
  for (i=c1;i<=c2;i++)
    for (j=r1;j<=r2;j++)
      {
	x=i-x0;
	y=j-y0;
	switch (filtype){
	case 1: {ff=FilterFunc1(x,y,a);break;}
	case 2: {ff=FilterFunc2(x,y,a);break;}
	case 3: {ff=FilterFunc3(x,y,a,b);break;}
	default: {fprintf(stderr,"Unknown FilterFunc%i.. Aborting!\n",
			  filtype);return(-1.0);}
	} //end switch
	if (ff>0) np++;;
	sum += apix[j][i]*ff;
	wsum+=ff;
      }
  if (debug) printf("Number of pixels inside the aperture: %i\n",np);
  if (debug) printf("Sum = %e / Wsum = %e  => ",sum,wsum);
  *nl=np;
  if (psum>0) sum=sum/wsum;
  if (debug) printf("%e\n",sum);
  return(sum);
}
