/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/
#include "fitsio.h"
#include "stdlib.h"
#include "string.h"
/*be sure to compile with -Lcfitsio */

int writefits(char *fn, double **ipix, 
		 long naxes[3],int *status)
{
  fitsfile *fptr;
  char *ctmp;
  double *dtmp;
  int *itmp,x,y;

  dtmp=(double *)malloc(sizeof(double)*naxes[0]);
  itmp=(int *)malloc(sizeof(double)*naxes[0]);
  ctmp=(char *)malloc(sizeof(char)*200);
  if (*status<=0) {
    ffinit(&fptr,fn,status); //initialize the new FITS file

    if (*status) {fprintf(stderr,"Writefits @ 2: ");ffrprt(stderr, *status);}
    ffcrim(fptr,16,0,naxes,status);  //  Create #0 header
    if (*status) {fprintf(stderr,"Writefits @ 3: ");ffrprt(stderr, *status);}
    ffmahd(fptr,1,NULL,status); // move forward top #1 header
    ffcrim(fptr,-32,2,naxes,status); // create the #1 header

    /*Put data into the array*/
    for (y=0;y<naxes[1];y++) { //write out a row at a time
      for (x=0;x<naxes[0];x++) dtmp[x]=ipix[y][x];
      ffppr(fptr,TDOUBLE,(y*naxes[0]+1),naxes[0],dtmp,status);
    }
    
    ffclos(fptr,status);
  }
  return(*status);
}
