/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/
#include "fitsio.h"
#include "stdlib.h"
#include "string.h"
/*be sure to compile with -Lcfitsio */

int writeoutfits(char *fn, char *fc, double **ipix, 
		 long naxes[3],int *status)
{
  fitsfile *fptr,*gptr;
  char *ctmp;
  double *dtmp;
  int *itmp,x,y;

  dtmp=(double *)malloc(sizeof(double)*naxes[0]);
  itmp=(int *)malloc(sizeof(double)*naxes[0]);
  ctmp=(char *)malloc(sizeof(char)*200);
  if (*status<=0) {
    ffinit(&fptr,fn,status); //initialize the new FITS file
    ffopen(&gptr,fc,READONLY,status);
    ffmahd(gptr,1,NULL,status); // position at first header unit
    ffcphd(gptr,fptr,status); // copy the zeroeth header over
    sprintf(ctmp,"H-alpha ghost removed by ghostbgone from %s",fc);
    ffphis(fptr,ctmp,status);
    ffmahd(gptr,2,NULL,status); // move forward one header unit
    ffcphd(gptr,fptr,status); // copy the first header over
    ffpdat(fptr,status);
    ffphis(fptr,ctmp,status);
    for (y=0;y<naxes[1];y++) { //write out a row at a time
      for (x=0;x<naxes[0];x++) dtmp[x]=ipix[y][x];
      ffppr(fptr,TDOUBLE,(y*naxes[0]+1),naxes[0],dtmp,status);
    }
    ffmahd(gptr,3,NULL,status); // move forward one header unit
    ffcphd(gptr,fptr,status); // copy the second header over
    for (y=0;y<naxes[1];y++) { //read in and write out a row at a time
      ffgpv(gptr,TDOUBLE,(y*naxes[0]+1),naxes[0],NULL,dtmp,NULL,status);
      ffppr(fptr,TDOUBLE,(y*naxes[0]+1),naxes[0],dtmp,status);
    }
    ffmahd(gptr,4,NULL,status); // move forward one header unit
    ffcphd(gptr,fptr,status); // copy the third header over
    for (y=0;y<naxes[1];y++) { //read in and write out a row at a time
      ffgpv(gptr,TDOUBLE,(y*naxes[0]+1),naxes[0],NULL,dtmp,NULL,status);
      ffppr(fptr,TDOUBLE,(y*naxes[0]+1),naxes[0],dtmp,status);
    }
 
    ffclos(gptr,status);   
    ffclos(fptr,status);
  }
  return(*status);
}
